module control
(
	input				clk,			// system clock
	input				rst_n,			// system reset, active low
	input	    [3:0]	sw,	
	input      	[2:0] 	key,
	input       [11:0] temp_in,
	
	input              	rx_data_valid,
	input       [7:0]  rx_data_in,
	
	output  reg 		tx_data_valid,
	output  reg [7:0]	tx_data_out,
	
	output  reg	[31:0]	time_out,
	output  reg	[31:0]	temp_out,		
	
	output	reg		[15:0]	cycle
); 



	
	reg time_buffer_flag;//ʼʱ
	reg time_set_flag;	//趨
	reg tone_set_flag; //ݴ
	reg tone_flag;    //ױ־λ
	reg tone_finish_flag;   //׽
	reg pwm_flag;      //pwm־λ
	reg pwm_finish_flag;	   //pwm
	reg temp_tx_flag;  //ʼ¶

	
	

	reg [29:0] cnt_1m;
	always @(posedge clk or negedge rst_n)begin //ʱһ
		if(!rst_n) cnt_1m <= 1'b0;
		else if(cnt_1m >= 30'd719_999_999) cnt_1m <= 1'b0;
		else cnt_1m <= cnt_1m + 1'b1;
	end
	
		
	reg time_1plus_flag;
	reg time_60plus_flag;
	reg time_plus_full;	
	always@(posedge clk or negedge rst_n) begin       //***********************************************//
		if(!rst_n)begin
			time_1plus_flag <= 1'b0;
			time_60plus_flag <= 1'b0;
			time_buffer_flag <= 1'b0;
			tone_flag <= 1'b0;
		end else begin	
			if(time_buffer_flag ==1'b0)begin           //ֹͣʱʱ
				case(key)
					3'b100:time_60plus_flag <= 1'b1;							//4ʱ
					3'b010:time_1plus_flag <= 1'b1;								//3ӷ
					3'b001:time_buffer_flag <= 1'b1;							//2ʼʱ
					default:begin time_1plus_flag <= 1'b0;time_60plus_flag <= 1'b0;  end
				endcase
				if(tone_finish_flag == 1'b1) begin
					tone_flag <= 1'b0;       //ֹͣ
					time_buffer_flag <= 1'b1;//ʼʱ
				end
			end else if(tone_flag == 1'b0 )begin                              //ʱ
				if(cnt_1m >= 30'd719_999_999)begin				
					time_1plus_flag <= 1'b1;
				end else begin      
					time_1plus_flag <= 1'b0;
					time_60plus_flag <= 1'b0;
				end	
				
				if(key == 3'b001 && tone_set_flag == 1'b1 ) begin
					tone_flag <= 1'b1;	       //ʼ
					time_buffer_flag <= 1'b0; //ֹͣʱ
				end else begin
					tone_flag <= tone_flag ;
					time_buffer_flag <= time_buffer_flag ;
				end	
				
			end else begin
				time_1plus_flag <= 1'b0;
				time_60plus_flag <= 1'b0;	
			end
				
		end
	end
	
	
	
	reg [15:0] time_buffer;
	always@(posedge clk or negedge rst_n) begin       //**********************time+1*******************//
		if(!rst_n)begin			
			time_buffer[7:0] <= 8'b0;
		end else begin
			if(time_1plus_flag)begin
				if(time_buffer[3:0] >= 4'd9 && time_buffer[7:4] < 4'd5) time_buffer[7:0] <= time_buffer[7:0] + 4'd7;
				else if(time_buffer[3:0] >= 4'd9 && time_buffer[7:4] == 4'd5) begin
					time_buffer[7:0] <= 8'b0;
					time_plus_full <= 1'b1;				
				end else begin
					time_buffer[7:0] <= time_buffer[7:0] + 1'b1;
				end
			end else begin
				time_buffer[7:0] <= time_buffer[7:0];
				time_plus_full <= 1'b0;
			end
		end
	end
	
	
	always@(posedge clk or negedge rst_n) begin       //***********************time+60***************************//
		if(!rst_n)begin			
			time_buffer[15:8] <= 8'b0;
		end else begin
			if(time_60plus_flag||time_plus_full)begin
				if(time_buffer[11:8] >= 4'd9 && time_buffer[15:12] < 4'd2) time_buffer[15:8] <= time_buffer[15:8] + 4'd7;
				else if(time_buffer[11:8] >= 4'd3 && time_buffer[15:12] == 4'd2) time_buffer[15:8] <= 8'b0;
				else time_buffer[15:8] <= time_buffer[15:8] + 1'b1;
			end else begin
				time_buffer[15:8] <= time_buffer[15:8];
			end
		end
	end
	
	
	always@(posedge clk or negedge rst_n)
		if(!rst_n) time_out <= 32'b0;
		else begin 
			time_out[27:24] <= time_buffer[15:12];	      //*************************oledʾʱ*************************//
			time_out[19:16] <= time_buffer[11:8];
			time_out[11:8]  <= time_buffer[7:4];	
			time_out[3:0]   <= time_buffer[3:0];		
		end	

	
	
	reg cnt_rx ;
	reg [15:0]time_set;
	always@(posedge clk or negedge rst_n) begin       //*****************************uarttime_set********************//
		if(!rst_n)begin
			cnt_rx <= 1'b0;
			time_set <= 16'b0;
			time_set_flag <= 1'b0;
		end else begin
			if(time_buffer_flag == 1'b1&&time_set_flag == 0)begin    
				cnt_rx <= !cnt_rx;									
				if(cnt_rx == 1'b0)begin		
				end else begin
					time_set[7:0]  <= 8'd0;	
					time_set_flag <= 1'b1;
				end
			end else begin            
				cnt_rx <= cnt_rx;
				time_set <= time_set;
			end						
		end 
	end
	
	
	
	
		
	reg [255:0]  tone;   //32*8
	reg [4:0] cnt_rxn = 5'd0;
	always@(posedge clk or negedge rst_n) begin      //***********************uartȡ32************************//
		if(!rst_n)begin
			tone <= 256'b0;
			tone_set_flag <= 1'b0;
			cnt_rxn <= 5'd0;
		end else begin
			if(rx_data_valid && time_set_flag == 1'b1)begin  
				cnt_rxn <= cnt_rxn +1'b1;
				case(cnt_rxn)
					5'd0:tone[255:248] <= rx_data_in[7:0];
					5'd1:tone[247:240] <= rx_data_in[7:0];
					5'd2:tone[239:232] <= rx_data_in[7:0];
					5'd3:tone[231:224] <= rx_data_in[7:0];
					5'd4:tone[223:216] <= rx_data_in[7:0];
					5'd5:tone[215:208] <= rx_data_in[7:0];
					5'd6:tone[207:200] <= rx_data_in[7:0];
					5'd7:tone[199:192] <= rx_data_in[7:0];
					5'd8:tone[191:184] <= rx_data_in[7:0];
					5'd9:tone[183:176] <= rx_data_in[7:0];
					5'd10:tone[175:168] <= rx_data_in[7:0];
					5'd11:tone[167:160] <= rx_data_in[7:0];
					5'd12:tone[159:152] <= rx_data_in[7:0];
					5'd13:tone[151:144] <= rx_data_in[7:0];
					5'd14:tone[143:136] <= rx_data_in[7:0];
					5'd15:tone[135:128] <= rx_data_in[7:0];					
					5'd16:tone[127:120] <= rx_data_in[7:0];
					5'd17:tone[119:112] <= rx_data_in[7:0];
					5'd18:tone[111:104] <= rx_data_in[7:0];
					5'd19:tone[103:96] <= rx_data_in[7:0];
					5'd20:tone[95:88] <= rx_data_in[7:0];
					5'd21:tone[87:80] <= rx_data_in[7:0];
					5'd22:tone[79:72] <= rx_data_in[7:0];
					5'd23:tone[71:64] <= rx_data_in[7:0];
					5'd24:tone[63:56] <= rx_data_in[7:0];
					5'd25:tone[55:48] <= rx_data_in[7:0];
					5'd26:tone[47:40] <= rx_data_in[7:0];
					5'd27:tone[39:32] <= rx_data_in[7:0];
					5'd28:tone[31:24] <= rx_data_in[7:0];
					5'd29:tone[23:16] <= rx_data_in[7:0];
					5'd30:tone[15:8] <= rx_data_in[7:0];
					5'd31:tone[7:0] <= rx_data_in[7:0];
					default: tone <= tone;
				endcase
				if(rx_data_in[7:0]==8'hFF)tone_set_flag <= 1'b1;  //FF־
			end else begin
				cnt_rxn <= cnt_rxn;
				tone_set_flag <=tone_set_flag ;
				tone <= tone;
			end		
			
		end
	end
	
	

	always@(posedge clk or negedge rst_n) begin       //*************************uart¶***********************//
		if(!rst_n)begin
			pwm_flag <= 1'b0;
			temp_tx_flag <= 1'b0;			
		end else begin
			if(tone_flag ==1'b1) begin
				temp_tx_flag <= 1'b0;
			end else if(time_buffer[7:0] == time_set[7:0] && time_set_flag == 1'b1)begin
				temp_tx_flag <= 1'b1;
			end else if(tone_finish_flag == 1'b1)begin
				temp_tx_flag <= 1'b1;
			end else begin
				temp_tx_flag <= temp_tx_flag;
			end
			
			if(pwm_finish_flag==1'b1 ) begin 
				pwm_flag <= 1'b0;
			end else if(time_buffer[7:0] == time_set[7:0] && time_set_flag == 1'b1)begin
				pwm_flag <= 1'b1;
			end else begin 
				pwm_flag <= pwm_flag ;
			end
		end
	end			
			
			

	always@(posedge clk or negedge rst_n) begin       //***************************oledʾ¶****************************//
		if(!rst_n)begin
			temp_out <= 32'b0;
		end else begin			
			temp_out <= {4'b0,temp_in[11:8],4'b0,temp_in[7:4],4'b0,temp_in[3:0],8'b0};
		end
		
		if(tone_flag) temp_out <= temp_out;
	end
	

	
	
	reg [23:0] cnt_uart;
	always @(posedge clk or negedge rst_n)begin //ʱһ
		if(!rst_n) cnt_uart <= 1'b0;
		else if(cnt_uart >= 24'd11_999_999) cnt_uart <= 1'b0;
		else if (temp_tx_flag) cnt_uart <= cnt_uart + 1'b1;
		else cnt_uart <= cnt_uart;
	end
	
	
	
	always @(posedge clk or negedge rst_n)begin      //*********************ÿ뷢һ¶ʱݣַʾ***********************//
		if(!rst_n) begin 
			tx_data_valid <= 1'b0; 
			tx_data_out <= 1'b0; 
		end else begin
			if(temp_tx_flag)begin       //¶
				if(cnt_uart == 24'd10_599_999 ) begin //¶.λ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,temp_in[3:0]};			 
				end 
				else if(cnt_uart == 24'd11_999_999 ) begin //
					tx_data_valid <= 1'b1; 
					tx_data_out <= 8'd10;
				end
				else if(cnt_uart == 24'd11_099_999 ) begin //¶.λ 
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,4'b0};
				end 
				else if(cnt_uart == 24'd10_099_999 ) begin //.
					tx_data_valid <= 1'b1; 
					tx_data_out <= 8'd46;
				end 
				else if(cnt_uart == 24'd9_599_999 ) begin //¶ȵλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,temp_in[7:4]};
				end 
				else if(cnt_uart == 24'd9_099_999 ) begin //¶ȸλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,temp_in[11:8]};
				end 
				else if(cnt_uart == 24'd11_599_999 ) begin //"C"
					tx_data_valid <= 1'b1; 
					tx_data_out <= 8'd67;
				end 
				else if(cnt_uart == 24'd8_599_999 ) begin // 
					tx_data_valid <= 1'b1; 
					tx_data_out <= 8'd32;
				end 
				else if(cnt_uart == 24'd8_099_999 ) begin //ֵλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,time_buffer[3:0]};
				end
				else if(cnt_uart == 24'd7_599_999 ) begin //ָλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,time_buffer[7:4]};
				end
				else if(cnt_uart == 24'd7_099_999 ) begin //
					tx_data_valid <= 1'b1; 
					tx_data_out <= 8'd58;
				end
				else if(cnt_uart == 24'd6_599_999 ) begin //ʱλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,time_buffer[11:8]};
				end
				else if(cnt_uart == 24'd6_099_999 ) begin //ʱλ
					tx_data_valid <= 1'b1; 
					tx_data_out <= {4'd3,time_buffer[15:12]};
				end
				else begin 
					tx_data_valid <= 1'b0; tx_data_out <= tx_data_out;
				end
			end else begin
				tx_data_valid <= 1'b0; tx_data_out <= tx_data_out;
			end
		end
	end
	
	
	
		
	reg [28:0] cnt_pwm;
	always@(posedge clk or negedge rst_n)
		if(!rst_n) cnt_pwm <= 1'b0;
		else if(pwm_flag)cnt_pwm <= cnt_pwm + 1'b1;
		else cnt_pwm <= cnt_pwm;
			
			
	reg [26:0] cnt_tone;
	always@(posedge clk or negedge rst_n)
		if(!rst_n) cnt_tone <= 1'b0;
		else if(tone_flag) cnt_tone <= cnt_tone + 1'b1;
		else cnt_tone <= cnt_tone;




	reg [7:0] note; 
	always @(posedge clk or negedge rst_n)begin       //**************************************************//
		if(!rst_n) begin
			note <= 8'd0;
			pwm_finish_flag <= 1'b0;
		end else begin
			if(pwm_flag)begin
				case(cnt_pwm[28:24])
					5'd0: note <= 8'hA1;	//L1,
					5'd1: note <= 8'hA2;	//L2,
					5'd2: note <= 8'hA3;	//L3,
					5'd3: note <= 8'hB1;	//L4,
					5'd4: note <= 8'hB2;	//L5,
					5'd5: note <= 8'hB3;	//L6,
					5'd6: note <= 8'hC1;	//L7,
					5'd7: note <= 8'hC2;	//M1,
					5'd8: note <= 8'hC3;	//M2,
					5'd9: note <= 8'hA1;	//L1,
					5'd10: note <= 8'hA2;	//L2,
					5'd11: note <= 8'hC1;	//L3,
					5'd12: note <= 8'hA3;	//L4,
					5'd13: note <= 8'hB1;	//L5,
					5'd14: note <= 8'hB2;	//L6,
					5'd15: note <= 8'hB3;	//L7,
					5'd16: note <= 8'hC7;	//M1,
					5'd17: note <= 8'hC1;	//M2,
					default: begin note <= 8'h0;pwm_finish_flag <= 1'b1;	end	//cycleΪ0PWMռձΪ0͵ƽ
				endcase
			end else if(tone_flag)begin
				case(cnt_tone[26:22])
					5'd0:note <= tone[255:248] ;
					5'd1:note <= tone[247:240] ;
					5'd2:note <= tone[239:232] ;
					5'd3:note <= tone[231:224] ;
					5'd4:note <= tone[223:216] ;
					5'd5:note <= tone[215:208] ;
					5'd6:note <= tone[207:200] ;
					5'd7:note <= tone[199:192] ;
					5'd8:note <= tone[191:184] ;
					5'd9:note <= tone[183:176] ;
					5'd10:note <= tone[175:168] ;
					5'd11:note <= tone[167:160] ;
					5'd12:note <= tone[159:152] ;
					5'd13:note <= tone[151:144] ;
					5'd14:note <= tone[143:136] ;
					5'd15:note <= tone[135:128] ;					
					5'd16:note <= tone[127:120] ;
					5'd17:note <= tone[119:112] ;
					5'd18:note <= tone[111:104] ;
					5'd19:note <= tone[103:96] ;
					5'd20:note <= tone[95:88] ;
					5'd21:note <= tone[87:80] ;
					5'd22:note <= tone[79:72] ;
					5'd23:note <= tone[71:64] ;
					5'd24:note <= tone[63:56] ;
					5'd25:note <= tone[55:48] ;
					5'd26:note <= tone[47:40] ;
					5'd27:note <= tone[39:32] ;
					5'd28:note <= tone[31:24] ;
					5'd29:note <= tone[23:16] ;
					5'd30:note <= tone[15:8] ;
					5'd31:note <= 8'hFF ;
					default:  note <= 8'h0;		//cycleΪ0PWMռձΪ0͵ƽ
				endcase				
			end else begin
				note <= 8'h0;
			end
		end		
	end
	
	

	always @(posedge clk or negedge rst_n)begin       //***********************ƵʶӦ***************************//
		if(!rst_n) begin
			cycle <= 8'b0;
			tone_finish_flag <= 1'b0;
		end else begin
			case(note)
				8'hA1: cycle <= 16'd45872;	//L1,
				8'hA2: cycle <= 16'd40858;	//L2,
				8'hA3: cycle <= 16'd36408;	//L3,
				8'hA4: cycle <= 16'd34364;	//L4,
				8'hA5: cycle <= 16'd30612;	//L5,
				8'hA6: cycle <= 16'd27273;	//L6,
				8'hA7: cycle <= 16'd24296;	//L7,
				8'hB1: cycle <= 16'd22931;	//M1,
				8'hB2: cycle <= 16'd20432;	//M2,
				8'hB3: cycle <= 16'd18201;	//M3,
				8'hB4: cycle <= 16'd17180;	//M4,
				8'hB5: cycle <= 16'd15306;	//M5,
				8'hB6: cycle <= 16'd13636;	//M6,
				8'hB7: cycle <= 16'd12148;	//M7,
				8'hC1: cycle <= 16'd11478;	//H1,
				8'hC2: cycle <= 16'd10215;	//H2,
				8'hC3: cycle <= 16'd9140;	//H3,
				8'hC4: cycle <= 16'd8598;	//H4,
				8'hC5: cycle <= 16'd7653;	//H5,
				8'hC6: cycle <= 16'd6818;	//H6,
				8'hC7: cycle <= 16'd6072;	//H7,
				8'hD1: cycle <= 16'd5730;	//V1,
				8'hD2: cycle <= 16'd5106;	//V2,
				8'hD3: cycle <= 16'd4548;	//V3,
				8'hD4: cycle <= 16'd4294;	//V4,
				8'hD5: cycle <= 16'd3826;	//V5,
				8'hD6: cycle <= 16'd3409;	//V6,
				8'hD7: cycle <= 16'd3036;	//V7,
				8'hFF: begin cycle <=16'd0; tone_finish_flag <= 1'b1; end
				default:cycle = 16'd0;
			endcase
		end
	end
	
	
endmodule